POJ - 2777——Count Color(懒标记线段树二进制)

Count Color

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 53639   Accepted: 16153

Description

Chosen Problem Solving and Program design as an optional course, you are required to solve all kinds of problems. Here, we get a new problem.

There is a very long board with length L centimeter, L is a positive integer, so we can evenly divide the board into L segments, and they are labeled by 1, 2, ... L from left to right, each is 1 centimeter long. Now we have to color the board - one segment with only one color. We can do following two operations on the board:

1. "C A B C" Color the board from segment A to segment B with color C. 
2. "P A B" Output the number of different colors painted between segment A and segment B (including).

In our daily life, we have very few words to describe a color (red, green, blue, yellow…), so you may assume that the total number of different colors T is very small. To make it simple, we express the names of colors as color 1, color 2, ... color T. At the beginning, the board was painted in color 1. Now the rest of problem is left to your.

Input

First line of input contains L (1 <= L <= 100000), T (1 <= T <= 30) and O (1 <= O <= 100000). Here O denotes the number of operations. Following O lines, each contains "C A B C" or "P A B" (here A, B, C are integers, and A may be larger than B) as an operation defined previously.

Output

Ouput results of the output operation in order, each line contains a number.

Sample Input

2 2 4
C 1 1 2
P 1 2
C 2 2 2
P 1 2

Sample Output

2
1

题目链接:

http://poj.org/problem?id=2777

题目大意:

给L长度的木板涂色,一开始木板颜色相同,有T种颜色可用,O(不是零是 ou )次操作。每次操作有两种情况,一种是改变木板的颜色也就是给木板的某个区间涂色,另一种是询问给定区间的颜色种类数量。

题目分析:

这题比较明显是使用线段树解决问题,但是有一个问题是:超时。那么如何解决这个问题呢,这时候就引进了一个很优秀的操作————懒标记。

懒标记是什么呢?“懒”的意思很明显了,就是说在不涉及某个节点的情况下,选择性的变懒,不去改变。举个例子:

如果改变区间的颜色,那么我们可以不去找到区间内每个叶子然后改变每个叶子的颜色,而是找到在这个区间内的另外的区间(可能是一个区间,也可能是很多个区间,也有可能包括了一个区间和n个叶子,也有可能只有叶子),把找到的区间改变颜色,并把区间懒标记。

懒标记后,如果再次查询到该节点,那么需要做下推操作,即把该节点的颜色,下推给子节点,改变子节点的颜色,并把该节点懒标记清空。

对于颜色的存储,这题还是需要注意的。我们很容易想到存储每个节点区间的颜色种类数,但是这样存储问题就来了,怎么确定子节点中颜色是否相同。所以有引进一个骚操作,二进制表示法。

我们可以看到颜色的种类不超过30种,所以可以用一位二进制表示一种颜色,即颜色一为(1),颜色二为(10),颜色三为(100),颜色四为(1000),依次类推。

那么我们存储父节点颜色怎么存储呢?      或操作(|)。
tree[k].color=tree[k<<1].color|tree[k<<1|1].color;

解释一下:或操作,如果颜色相同,那么结果仍保存该颜色;如果子节点一个有该颜色,另一个没有该颜色,操作结果仍然有该颜色;如果两个子节点都没有该颜色,那么结果也没有该颜色。

最后得到的结果只需要判断在二进制下有几个1就可以了。

还要注意一个坑就是 A和B谁大谁小不确定。

AC代码如下:
#include<stdio.h>

const int MAX=1e6+5;

struct a{
    int left,right;
    int  lazy,ans;
}tree[MAX<<2];

void init(int length)  //懒标记初始化
{
    for(int i=1;i<=length;i++)
    {
        tree[i].lazy=0;
    }
}

void btree(int k,int l,int r)   //建树操作
{
    tree[k].left=l;tree[k].right=r;
    if(l==r)
    {
        tree[k].ans=1;return ;
    }
    int mid=(l+r)>>1;
    btree(k<<1,l,mid);
    btree(k<<1|1,mid+1,r);
    tree[k].ans=(tree[k<<1].ans|tree[k<<1|1].ans);
}

void push_down(int k)    //下推
{
    if(tree[k].left==tree[k].right) return ;
    tree[k<<1].lazy=tree[k].lazy;
    tree[k<<1|1].lazy=tree[k].lazy;
    tree[k<<1].ans=1<<(tree[k].lazy-1);
    tree[k<<1|1].ans=1<<(tree[k].lazy-1);
    tree[k].lazy=0;
}

void datetree(int k,int l,int r,int co)  //涂色
{
    if(tree[k].left>=l&&tree[k].right<=r)
    {
        tree[k].ans=1<<(co-1);
        tree[k].lazy=co;
        return ;
    }
    if(tree[k].lazy) push_down(k);
    int mid=(tree[k].left+tree[k].right)>>1;
    if(mid<l)
    {
        datetree(k<<1|1,l,r,co);
    }
    else if(mid>=r)
    {
        datetree(k<<1,l,r,co);
    }
    else
    {
        datetree(k<<1,l,r,co);
        datetree(k<<1|1,l,r,co);
    }
    tree[k].ans=(tree[k<<1].ans|tree[k<<1|1].ans);
}

int ans;
void query(int k,int l,int r)    //询问
{
    if(tree[k].left>=l&&tree[k].right<=r)
    {
        ans=(ans|tree[k].ans);
        return ;
    }
    if(tree[k].lazy) push_down(k);
    int mid=(tree[k].left+tree[k].right)>>1;
    if(mid<l)
    {
        query(k<<1|1,l,r);
    }
    else if(mid>=r)
    {
        query(k<<1,l,r);
    }
    else
    {
        query(k<<1,l,r);
        query(k<<1|1,l,r);
    }
}

int main()
{
    int L,color,q;
    char n[10];
    scanf("%d%d%d",&L,&color,&q);
    init(L);
    btree(1,1,L);
    while(q--)
    {
        scanf("%s",n);
        if(n[0]==‘C‘)
        {
            int a,b,c;
            scanf("%d%d%d",&a,&b,&c);
            if(a>b){
                int t=a;a=b;b=t;
            }
            datetree(1,a,b,c);

        }
        else
        {
            int a,b;
            ans=0;
            int cnt=0;
            scanf("%d%d",&a,&b);
            if(a>b){
                int t=a;a=b;b=t;
            }
            query(1,a,b);
            while(ans)
            {
                if(ans%2) cnt++;
                ans/=2;
            }
            printf("%d\n",cnt);
        }
    }
    return 0;
}

原文地址:https://www.cnblogs.com/noback-go/p/10541560.html

时间: 2024-11-10 18:18:30

POJ - 2777——Count Color(懒标记线段树二进制)的相关文章

POJ 2777 Count Color(位运算+线段树+lazy+区间更新)

Count Color Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 39905   Accepted: 12034 Description Chosen Problem Solving and Program design as an optional course, you are required to solve all kinds of problems. Here, we get a new problem.

poj 2777 Count Color(线段树区间修改)

题目链接:http://poj.org/problem?id=2777 题目意思:就是问你在询问的区间里有几种不同的颜色 思路:这题和一般的区间修改差不多,但是唯一不同的就是我们要怎么计算有种颜色,所以这时候我们就需要把延时标记赋予不同的意义,当某段区间有多种颜色时就赋值为-1,当为一种颜色时就把它赋值为这个颜色的号数.这儿我们要怎么统计询问区间不同的颜色数叻,为了不重复计算同一种颜色,那么我们就需要用一个数组来标记计算过的颜色,当我们下次遇到时就不需要再次计算了.... 代码核心处就在计数那儿

poj 2777 Count Color【线段树段更新】

题目:poj 2777 Count Color 题意:给出一段1 * n 的栅栏,有两种操作,第一种:把 l -- r 全部染成同一颜色t,第二种,查询 l---r 一共有多少种颜色. 分类:线段树 分析:我们可以给每个节点加一个标记,标记当前节点是否只有一种颜色,然后对只有一种颜色的节点如果要染色的话,那么他会变成几种颜色的,这时候记得向下更新一次就好,统计的时候统计节点有单个颜色的颜色就好. 代码: #include <cstdio> #include <cstring> #i

POJ 2777 Count Color(线段树)

题目地址:POJ 2777 我去..延迟标记写错了.标记到了叶子节点上....这根本就没延迟嘛...怪不得一直TLE... 这题就是利用二进制来标记颜色的种类.然后利用或|这个符号来统计每个区间不同颜色种数. 代码如下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <stdlib.h> #include <math.h

POJ 2777 Count Color (线段树区间更新加查询)

Description Chosen Problem Solving and Program design as an optional course, you are required to solve all kinds of problems. Here, we get a new problem. There is a very long board with length L centimeter, L is a positive integer, so we can evenly d

POJ 2777 Count Color(线段树)

POJ 2777 Count Color 题目链接 就一个线段树,颜色二进制表示就可以,成段更新成段查询延迟操作 代码: #include <cstdio> #include <cstring> #include <algorithm> using namespace std; #define lson(x) ((x<<1)+1) #define rson(x) ((x<<1)+2) const int N = 100005; struct No

POJ 2777 Count Color (线段树+位运算)

题意很简单了,对一个区间有两种操作: 1. "C A B C" Color the board from segment A to segment B with color C. //A~B涂上颜色C 2. "P A B" Output the number of different colors painted between segment A and segment B (including). //输出A~B间颜色的种类数 题目链接:http://poj.o

POJ 2777 &amp;&amp; ZOJ 1610 &amp;&amp;HDU 1698 --线段树--区间更新

直接将这3题 放一起了  今天在做线段树的东西 这3个都是区间更新的 查询方式互相不同 反正都可以放到一起吧 直接先上链接了 touch me touch me touch me 关于涉及到区间的修改 -- 区间更新的话 分为 增减 或者 修改 主要就是个 laze 标记 就是延迟更新 对于区间更新的写法 一般是有2种 其一 仔细划分到每个细小的区间    另一 粗略划分 反正 ==我的代码里会给出2种写法 看自己喜好 hdu 1 //线段树 成段更新 ---> 替换 根结点的查询 2 3 #i

POJ 2777 count color(线段树,lazy标记)

这里有一个思想:我们在更新的时候不必要更新到叶子节点,只要更新到当前区间包含线段树区间即可. 设计一个标志位,更新到此. A Simple Problem with Integers 也是一个类似的题目 设计两个函数 push_down 将结点信息传递到下层节点(inc, sub,) push_up      将下层节点信息反馈到上层(max,min,count) #include <map> #include <set> #include <queue> #inclu